<?
require_once "../common.php";
require_once "../conf.php";
require_once "../lib/dbinit.php";
require_once "../lib/PodAuth.php";
$auth = new PodAuth();
$auth->start();
$db = dbinit_connect();
if(!$auth->isGroupOwner(GROUP_NAME)) {
  echo "You are not a valid group owner.";
  exit;
}


function print_handle_enter_js()
{
    echo <<<EOF
    function handleEnter (field, event) {
        //USAGE: onKeyPress='handleEnter(this,event)'
        var keyCode = event.keyCode ? event.keyCode
                                    : event.which ? event.which
                                                : event.charCode;
        if (keyCode == 13) {
            var i;
            for (i = 0; i < field.form.elements.length; i++)
                if (field == field.form.elements[i])
                    break;
            i = (i + 1) % field.form.elements.length;
            field.form.elements[i].focus();
            return false;
        } 
        else {return true;}
    }
EOF;
}

function print_subscribe_form() 
{
    echo "
    <html>
    <head>
    <title>Bulk subscription</title>
    <script>";
    print_handle_enter_js();
    echo <<<EOF
    </script>
    </head>

    <body>
      <a href=".."> &lt;--- Back to Home </a>
    <h1>Bulk subscription</h1>
    This lets you subscribe many new users at once.  Each will receive
    an email telling them how to fully join the group
    <br><br>

    <form method=POST>
        Input a list of email addresses, one address per line.
        <br>
        <textarea name=emails cols=40 rows=20></textarea>
        <br><br>
        Message to these people to be included in their notification (optional):
        <br>
        <textarea name=usermessage cols=40 rows=5></textarea>
        <br>
        <input type=submit name=submit value="Subscribe these people">
    </form>
    <input type=button value="Cancel" onClick="history.back()">
    </body></html>
EOF;
}

function make_body($towhom_email, $bywhom, $usermessage)
{
    global $auth;
    $msg  = "You have been subscribed by $bywhom";
    $msg .= " to the Deme group \"".GROUP_LONGNAME."\"\n";
    if($usermessage ) {
        $msg .="\n\n$bywhom says:\n\n";
        $msg .= $usermessage;
        $msg .= "\n\n";
    }
    $msg .= "You will receive emails from the discussions in in the group, \n";
    $msg .= "but you will need to register to fully participate.\n\n";
    $msg .= "Click the link below to get your username and password:\n";
    $msg .= "  ".POD_URL_ROOT."/main/invitee-enter.php?";
    $msg .= "email=".urlencode($towhom_email) ."\n";
    $msg .= "\n\n";
    $msg .= "To decline, and get off the emailings, click this:\n";
    $msg .= "  ".POD_URL_ROOT."/main/nonuser-unsubscribe.php?";
    $msg .= "email=".urlencode($towhom_email) ."\n";
    
    return $msg;
}
    
function register_from_post()
{
    global $auth, $db;
    $metadb = dbinit_meta_connect();
    $selfrow = $metadb->getRow("SELECT * FROM users WHERE username='".
                            $auth->getUsername()."'");


    if($selfrow['firstname'] || $selfrow['lastname']) {
        $name = $selfrow['firstname'] ." ". $selfrow['lastname'];
    } else {
        $name = $selfrow['username'];
    }
    
    $subj = GROUP_NAME ." - $name has asked you to join this Deme group";
    $from = "$name <".$selfrow['email'].">";
    
    $emails = explode("\n", stripslashes($_POST['emails']));
    if($_POST['usermessage'] && !preg_match('/^\s*$/', $_POST['usermessage'])) {
        $usermessage = stripslashes($_POST['usermessage']);
    } else {
        $usermessage = false;
    }
    foreach($emails as $email) {
        $email = trim($email);
        if(preg_match('/^\s*$/', $email)) continue;
        if(! preg_match('/.*@.*/', $email)) {
            echo "<B>".$email."</B> doesn't look like a valid email address<BR>";
            continue;
        }

        $already_subscribed = $db->getAll("SELECT * FROM nonuser_subscribers WHERE email='".addslashes($email)."'");

        
        $already_registered_username = $metadb->getOne("SELECT users.username 
            FROM user_permissions
            LEFT JOIN users ON users.username = user_permissions.username
            WHERE email = '".addslashes($email)."'
              AND user_permissions.groupname = '".addslashes(GROUP_NAME)."'
        ");

        if($already_subscribed) {
            echo "<B>".htmlspecialchars($email)."</B> is already subscribed.<BR>";
        } else if($already_registered_username) {
            echo "<B>".htmlspecialchars($email)."</B> is already taken by the user <B>$already_registered_username</B> in this group.<BR>";
        } else {
            $body = make_body($email, $name, $usermessage);

            echo "<PRE>------------------ Sending message:\n";
            echo "To: $email\n";
            echo "From: ".htmlspecialchars($from)."\n";
            echo "Subject: ".htmlspecialchars($subj)."\n\n";
            echo htmlspecialchars($body);
            echo "------------------- End message.\n\n";

            mail($email, $subj, $body, 
                "From: $from\r\n");

            //---- enter into db!
            $db->query("INSERT nonuser_subscribers SET email='".addslashes($email)."'");
        }
    }

    
    echo "<BR> <a href=..>Back to home</a>";
}


if(!isset($_POST['submit'])) {
    print_subscribe_form();
} else {
    register_from_post();
}
