<?
require_once "../conf.php";

require_once "../common.php";
require_once "../lib/dbinit.php";
require_once "../lib/Document.php";
require_once "../lib/PodAuth.php";
$db = dbinit_connect();

assert(isset($_REQUEST['marea_id']));

$parent_doc_id = isset($_REQUEST['parent_doc_id']) ?
        $_REQUEST['parent_doc_id'] : 0;
$marea_id = $_REQUEST['marea_id'];
$doctype = isset($_REQUEST['doctype']) ? $_REQUEST['doctype'] : 'plaintext';

//Remember: global varialbes here *have* slashes added already.

if(isset($_REQUEST['submit'])) {
    assert(isset($_REQUEST['doc_text'],$_REQUEST['preface_text'],$_REQUEST['name']));
    $doc_text = $_REQUEST['doc_text'];
    $preface_text = $_REQUEST['preface_text'];
    //Fun fact: mysql INSERT strips trailing whitespace of new entries
    //So we'd better strip it off now before it gets inconsistently treated by
    //The very-honest Document::getFilename
    $name = trim($_REQUEST['name']);
    if(!$name) $name = "[Untitled Document]";
} else if ($parent_doc_id && !isset($_REQUEST['submit'])) {
//     $framesetdoc = new Document();
    $doctype = fetchDocumentTypeFromDB($db, $parent_doc_id);
    $framesetdoc = newDocument($doctype);
    $framesetdoc->fillFromDB($db, $parent_doc_id);
//     vardump($framesetdoc);
//     vardump($framesetdoc->name);

    $doc_text = addslashes($framesetdoc->getOrigText());
    $name = addslashes("$framesetdoc->title");
    $preface_text = "This is a revision of \"$name\"";
} else {
    $doc_text = "";
    $preface_text = "Here\\'s the new document, everyone";
    $name = "new document";
}

$auth = new PodAuth();
$auth->start();
if(!$auth->getMembership($marea_id)) {trigger_error("can't make a new doc here"); die;}

$author = $auth->getUsername();


function make_hidden_transmitter($assoc_array)
// The output of this goes into a <FORM> field.
{
    $s = "";
    foreach($assoc_array as $k => $v) {
        $s .= ' <input type=hidden ';
        $s .=        ' name ="' .$k. '"';
        $s .=        ' value="' .$v. '">';
    }
    return $s;
}

if (!isset($_POST['submit'])) {
?>

<HTML>
<HEAD>
<link rel="stylesheet" type="text/css" href="marea.css.php">
<link rel="stylesheet" type="text/css" href="ws.css.php">

<!-- <script src=marea_common.js.php> </script> -->
<script>
function confirm_submit()
{
    return confirm("Are you sure you want to post this document?");
}
</script>
</head>
      
<BODY onLoad="
<? assert(isset($doctype));
    echo "var radio = document.getElementById('doctype_{$doctype}_radio');";
    echo "radio.checked = true;";
    echo "typechoose_click(radio);";
?>
">
<h1>
<?=$parent_doc_id ? 
    "Post a revision of \"".htmlspecialchars(stripslashes($name))."\"" : 
    "Post a new document"
 ?>
</h1>

<form method=POST enctype=multipart/form-data>
<P><b>Document title:</b> <font size=-1>This should be very short, e.g. 1 or 2 words.</font>
    <input type=text 
           name="name"
           value="<?=htmlspecialchars(stripslashes($name));?>" 
           style="width:100%;"></P>
<P><b>Poster:</b> <?=htmlspecialchars($author)?> </P>
<P><b>Preface:</b> <font size=2>this will appear both above the document text, and also as a comment in the discussion.  You may change it at a later time, though the original announcement will remain in the discussion index.</font>
</P>

<textarea name="preface_text" class="preface_text"
      rows=4 cols=20 style="width:100%;" wrap="virtual">
<?=htmlspecialchars(stripslashes($preface_text))?>
</textarea>

<BR><BR>

<script>
GLOBAL_cur_type = "nonetype";
function typechoose_click(radio)
{
    input_id  = "input_for_" + GLOBAL_cur_type;
    document.getElementById(input_id).style.display = 'none';

    GLOBAL_cur_type = radio.value;
    input_id  = "input_for_" + GLOBAL_cur_type;
    document.getElementById(input_id).style.display = 'block';

    document.getElementById("submit").style.display = 'block';
}
</script>

<P>Document type?
<span class=radioclass> <?//hack for IE6 ?>
    <input type=radio  name=doctype value=plaintext id=doctype_plaintext_radio
     onClick="typechoose_click(this);"> Plain Text
    &nbsp; &nbsp; &nbsp;
    <input type=radio  name=doctype value=upload   id=doctype_upload_radio
     onClick="typechoose_click(this);">
    Uploaded file of any type (audio, video, picture, Word, PDF...)
</span>

<div id=input_for_nonetype> </div>

<div id=input_for_plaintext style="display:none;">
<P><b>Document text:</b><BR>
<textarea name="doc_text" class="doc_text"
    rows=20 cols=20 style="width:100%;" wrap="virtual">
<?=stripslashes($doc_text);?>
</textarea>
</div>

<div id=input_for_upload style="display:none;">
    <?
    $maxsize = get_cfg_var('upload_max_filesize');
    $maxsize_megs = preg_replace('/M$/','', $maxsize);
    $maxsize_bytes = $maxsize_megs * 1000 * 1000;

    if($parent_doc_id && $doctype == 'upload') {
    ?>
    <P><b>Previous file:</b>
       &nbsp; <?= $framesetdoc->printForWorkspace($db) ?>   
    <? } ?>
    <P><b>File to upload:</b>
        <input type=file name=userfile>
    <P>Maximum filesize is <?=$maxsize?><BR>
    <input type=hidden name=MAX_FILE_SIZE value=<?=$maxsize_bytes?>>
</div>

<?=make_hidden_transmitter(Array('parent_doc_id' => $parent_doc_id,
                                 'marea_id' => $marea_id));?>

<input type=submit name="submit" id="submit" value="Post this Document"
    onClick="return confirm_submit();" style="display:none;">
</form>
</body></html>

<? } /* ends if(!$submit) */

/* TODO: add a previewer step.  will require changes thruout htis file */
else {
    /* ---------------- enter into db [and elsewhere]! -------------------- */

    $doc = newDocument($doctype);
    $doc->fillFromInput(stripslashes($name), $marea_id, $parent_doc_id,
                            stripslashes($preface_text), $author, $doctype);
    if($doctype == 'plaintext') {
        $doc->fillDoctypeSpecifics(stripslashes($doc_text));
    } else if($doctype == 'upload') {
      if($_FILES['userfile']) {
        $doc->fillDoctypeSpecifics(
                stripslashes($_FILES['userfile']['name']),
                ($_FILES['userfile']['type']),
                ($_FILES['userfile']['tmp_name']));
      } else { echo("empty upload"); }
    }

    $doc->storeAsNew($db);

    /* the preface docref -- only partial information yet.*/
    $q = "INSERT refs SET
            referrent_type = 'doc',
            referrent_id   = $doc->item_id";
    
    $db->query($q);
    $preface_ref_id = $db->getOne("SELECT LAST_INSERT_ID()");

    /* ---- msgs ---- */
    $msg_insert_query  = "INSERT msgs SET 
        subj           = 'New Document: \"$name\"',
        msgtext        = '$preface_text',
        discoowner_id  = $marea_id,
        in_reply_to    = 0,
        when_posted    = NOW(),
        thread_depth   = 0,
        author         = '$author',
        primary_ref_id = $preface_ref_id,
        num_replies    = 0";
    $db->query($msg_insert_query);
    $preface_msg_id = $db->getOne("SELECT LAST_INSERT_ID()");

//echo "<script>alert($preface_msg_id);</script>";
    
    /* --- Finalize the docref in the DB --- */
    $db->query("UPDATE refs SET
                  referrer_id   = $preface_msg_id,
                  referrer_type = 'msg'
                WHERE ref_id = $preface_ref_id");

    /* --- Finalize the doc --- */
    $doc->storeFinalize($db, $preface_ref_id, $preface_msg_id);
    
    require "../lib/Notices.php";
    $n = new DocumentNotice($doc, $db);
    $n->notify();
?>

<HTML><BODY>
     Your new document has been added. <BR>
     <script>
     parent.finish(<?=$doc->doc_id?>, 'doc', <?=$preface_msg_id?>);
    </script>
</body></html>
    
<? } ?>
